#include "Logger.h"
#include <ctime>
#include <iomanip>

namespace MyEngine
{
	Logger* Logger::m_pInstance = NULL;

	Logger* Logger::Instance()
	{
		if(m_pInstance == NULL)
			m_pInstance = new Logger;

		return m_pInstance;
	}

	void Logger::DeleteInstance()
	{
		delete m_pInstance;
		m_pInstance = NULL;
	}

	Logger::Logger()
	{
		m_logFile.open(_T("log.txt"), std::ios_base::out | std::ios_base::trunc);
		m_logFile << std::setfill(_T('0'));
	}

	Logger::~Logger()
	{
		if(m_logFile)
			m_logFile.close();
	}

	void Logger::Write(const TString& strMessage)
	{
		if(m_logFile)
		{
			time_t rawtime;
			struct tm timeinfo;

			time(&rawtime);
			localtime_s(&timeinfo, &rawtime);

			m_logFile << _T("[");
			m_logFile << std::setw(2) << timeinfo.tm_hour;
			m_logFile << _T(":");
			m_logFile << std::setw(2) << timeinfo.tm_min;
			m_logFile << _T(":");
			m_logFile << std::setw(2) << timeinfo.tm_sec;
			m_logFile << _T("] ") + strMessage;
			m_logFile << std::endl;

			m_logFile.flush();
		}
	}
}
