#include "Timer.h"

namespace MyEngine
{
	Timer* Timer::m_pInstance = NULL;

	Timer* Timer::Instance()
	{
		if(m_pInstance == NULL)
			m_pInstance = new Timer;

		return m_pInstance;
	}

	void Timer::DeleteInstance()
	{
		delete m_pInstance;
		m_pInstance = NULL;
	}

	Timer::Timer()
	{
		if(::QueryPerformanceFrequency((LARGE_INTEGER*) &m_freq) != 0)
		{
			m_bUsingPerfCounter = true;
		}
		else
		{
			timeBeginPeriod(1);
			m_bUsingPerfCounter = false;
		}
	}

	Timer::~Timer()
	{
		if(!m_bUsingPerfCounter)
		{
			timeEndPeriod(1);
		}
	}

	uint Timer::Milliseconds()
	{
		uint ms;

		if(m_bUsingPerfCounter)
		{
			LONGLONG counts;
			QueryPerformanceCounter((LARGE_INTEGER*) &counts);
			ms = (uint) (1000 * counts / m_freq);
		}
		else
		{
			ms = timeGetTime();
		}

		return ms;
	}
}
